/*A*/ /* Head  */

/* {{{ */
/* for folding recognition */
/* }}} */

/****h*  functions.c *********
*
*	NAME
*   functions.c
*
*	FUNCTION
*    small useful functions without special meaning
*
*	CREATION DATE
*	  4-Mar-1997
*
*  HISTORY
*    040397 disconected this part from main.c
*
*  TODO
*
*  BUGS 
*
*  BEAST METHODS
*
*    kgv() smallest common multiple
*    ggt() biggest common divider
*
                *******
*/
/*E*/

/*-----------------------------------------*/

/*A*//*  External routines and Structures */

#include "define.h"

/*E*/

/*-----------------------------------------*/

/*A*/ int kgv (int value1, int value2) {
/****** functions.c/kgv *********
*
*	NAME
*	  kgv
*
*	FUNCTION
*    smallest common multiple
*    (kleinstes gemeinsames vielfaches)
*
*  SYNOPSIS
*    result = kgv(int value1,int value2)
*
*  RESULT
*    integer value of operation
*
*  BUGS
*    bug free
*
*  TODO
*    nothing to improve left
*
*  SEE ALSO
*    ggt()
*
*******
*/

  register int temp1 = value1;
  register int temp2 = value2;

  while (temp1 != temp2)
    {
      if (temp1 < temp2)
	temp1 += value1;
      else
	temp2 += value2;
    }				/* while */
  return temp1;
}
/*E*/

/*-----------------------------------------*/

/*A*/ int ggt (int value1, int value2) {
/****** functions.c/ggt *********
*
*	NAME
*	  ggt
*
*	FUNCTION
*    greatest common divider
*    (grter gemeinsamer Teiler)
*
*  SYNOPSIS
*    result = ggt(int value1,int value2)
*
*  RESULT
*    integer value of operation
*
*  BUGS
*    bug free
*
*  TODO
*    nothing to improve left
*
*  SEE ALSO
*    kgv()
*
*******
*/

  while (value1 != value2)
    {
      if (value1 > value2)
	value1 -= value2;
      else
	value2 -= value1;
    }				/* while */
  return value1;
}
/*E*/
